
//
// ui.js
//
// Script engine for the IPHost Network Monitor
//
// Component: web interface, client part.
//
// Copyright (c) ITelSib Ltd. 2007-2010. All rights reserved.
//

// Load default left (tree) data and enable the tree view


$(document).ready(
    function(){
	    nms_start();
});
var bookmarksheight = 0;
var sendreporturl = "";

var defaultReportingHours = 0;
var defaultReportingDays = 1;

var defaultEntriesPerPage = 30; // value from Db
var currEntriesPerPage = defaultEntriesPerPage; // current value

var firstDayOfWeek = 0; 
						// 0 - Mon
						// 1 - Tue
						// ...
						// 6 - Sun

var timeDiff = 0; // Difference between time in browser and time on server

function getServerDate()
{
	var ret = new Date();
	var fixed = new Date(ret.getTime() + timeDiff);
	return fixed;
}




function get_halfhour_date() {
    var tdate = getServerDate();
    var h = tdate.getMinutes();
    if (h > 0) {
// Up half-hour    
        tdate.setHours(tdate.getHours(), 30, 0);
        if (h > 30) {
            tdate = new Date(tdate.getTime() + 30*60*1000);
        }
    }
    return tdate;
}

// Startup
function nms_start() {  

    map.viewselect = map.view;

    loadReportingSettings();
	
	if ((map.start === undefined || map.stop === undefined) && (map.period_id === undefined)) {
        // No time interval specified at all: set it to default reporting period
        var sd = get_halfhour_date();
        sd = new Date(sd.getTime() - (defaultReportingDays*24*3600*1000) - (defaultReportingHours*3600*1000));
        map.start = date_datestring(sd)+'T'+date_timestring(sd);
    
        var ed = get_halfhour_date();
        map.stop = date_datestring(ed)+'T'+date_timestring(ed);
		
		map.period_id=15;
    }
	
    if (map.period_id !== undefined) {
        // Time interval specified by period_id
		$("#datemodeselect option").removeAttr("selected");
		$("#datemodeselect option[value='"+map.period_id+"']").attr("selected","selected");
		datemodeselect_change(null,map.period_id);
	} else {
        // Time interval specified by start_time and stop_time values
		populate_date_fields();
		$("#datemodeselect option").removeAttr("selected");
		$("#datemodeselect option[value='-']").attr("selected","selected");
	}
	
    map.pngquirk = (parseInt($.browser.version) < 7) && ($.browser.msie);
    $("#lr_order").click(function(){        
        if (($(this).attr('value_') == "0") || ($(this).attr('value_') == undefined)){
            
            $("#lr_order").attr('value_', 1);
            $("#lr_order div.lr_order").addClass("lr_order_up");
        } else{

            $("#lr_order").attr('value_', 0);
            $("#lr_order div.lr_order").removeClass("lr_order_up");
        }
    });
	
// On "send report" click
    $("#sendreport").click(function(){
        disableall();
        
        $("#sendreportform").css("display", "block");
// Fill fields        
        $("#sr_email").val($("div[@rel=adminemail]", $("#right")).eq(0).attr('email'));
        
        
        tmpn = $("#reportselect option:selected").html();
        if (tmpn != 'Logs') tmpn +=" report";
        tmpn+= " for "+ map["title"].replace(/&nbsp;/g, " ") +" (";
        tmpd = $("#datemodeselect option:selected").html();
        if (tmpd != 'Custom') tmpn += tmpd+": ";
        /*tmpn += $("#fromdateview").html()+" "+$("#fromtime option:selected").html() + " - ";*/
        tmpn += $("#fromdate").val() +" "+$("#fromtime option:selected").html() + " - ";
        /*tmpn += $("#todateview").html()+" "+$("#totime option:selected").html() + ")";*/
        tmpn += $("#todate").val()+" "+$("#totime option:selected").html() + ")";
        $("#sr_subject").val(tmpn);
        
// Save url        
        sendreporturl = lastLoadedUrl + '&send=1';            
    });
	
// On "DO send report click"    
    $("#dosend").click(function(){
        $("#sendreportform").css('display', 'none');
        $("#pleasewait").html("Sending report ...<img src=\"images/pleasewait.gif\" />").css('display', 'block');
        $.ajax({
			type:'POST',
            url: sendreporturl,
            data: {
                email: $("#sr_email").val(),
                subject: $("#sr_subject").val() 
            },
            success: function(data){
                $("#pleasewait").css('display', 'none');
                alert(data);                       
                enableall();
            },
			error: function (XMLHttpRequest, textStatus, errorThrown){
				$("#pleasewait").css('display', 'none');
				alert("Error: "+errorThrown+" "+textStatus);				
				enableall();
			}
        });
    });
    
// On "cancel send report" click
    $("#cancelsend, #sendformclose").click(function(){
        enableall();
        
        $("#sendreportform").css("display", "none");
    });       
	
// Show hide Log Report div
    var lr_needresize = false;
    $("#reportselect").change(function(){
        $("option", $(this)).each(function(){
            if (($(this).attr('value') == 4) && ($(this).attr('selected'))){
                $("#logreportsettings1").css('display', 'block');
                $("#logreportsettings2").css('display', 'block');
                $("#numberofentries").css('display', 'none');
                $(window).resize();
                lr_needresize = true;                 
            }
            else{
                $("#logreportsettings1").css('display', 'none');
                $("#logreportsettings2").css('display', 'none');
                $("#numberofentries").css('display', 'block');
                if (lr_needresize)
                    $(window).resize();
                lr_needresize = false;
            }
        });        
    });

    $("h2#byHost, h2#byType, h2#byState, h2#byTag, h2#favorites").click(
        function() {
            var idKey = $(this).attr("id");
            var prevId = selectedMonTypeId;
            selectedMonTypeView = monTypes[idKey];
            selectedMonTypeId = idKey;
            map.viewselect = selectedMonTypeView;
            map.view = map.viewselect;
            if (prevId != selectedMonTypeId)
            {
                reschedulePageReloading();
                viewselect_change();
            }
        }
    );

    $("body").mousemove(reschedulePageReloading);
	
    $("#reportselect option").removeAttr("selected");
    $("#reportselect option[value='"+map.id+"']").attr("selected","selected");
    
    $("#reportselect").change();
	
    map.stimes = '';
    map.speriod = '';
    if (map.period_id !== undefined) {
        map.speriod = '&period_id='+map.period_id; 
    }
    var treeurl = '/nms/ui_view?' + 'view=' + map.view + '&obj_type=' + map.obj_type + '&obj_id=' + map.obj_id;
    sessUID = getCookie('suid');
    
    if ((sessUID != undefined) && (parseInt(sessUID)>=0)){
                
        treeurl +="&uid="+sessUID;
    }
    d = getServerDate();
    treeurl += '&nocache='+d.getTime();
    
    var reporturl = '/nms/ui_report?obj_type=' + map.obj_type + '&obj_id=' + map.obj_id;
    
    // map.reportpart contains prefix and reporting object IDs only
    map["reportpart"] = reporturl;

    reporturl += "&view=" + map.viewselect;

// Multipage reports support
    var a = new Array("report_id", "start_idx", "stop_idx", "start_idx_p", "stop_idx_p");
    for (i = 0; i < a.length; i++) {
        if (map[a[i]] != undefined) {
            reporturl += "&" + a[i] + "=" + map[a[i]];
        }
    }
    reporturl +="&webui=1";
    
// Create onchange function for "viewselect" selector 
    
    $("#datemodeselect").change(datemodeselect_change);
    $("#fromtime").change(fromtime_change);
    $("#totime").change(totime_change);

// Setting defaults: View selector
    
    $("#generate").click(generate_click);
    $("#print").click(print_click);
    $("#togglecontrols").click(togglecontrols_click);
	    
    $("#fromdate").change(dstart_select);
    $("#todate").change(dend_select);
	
    if ((map.start !== undefined) && (map.stop !== undefined)) {
        map.stimes = '&start='+map.start+'&stop='+map.stop; 
    }
	
    reporturl += '&id='+ map.id + map.stimes + map.speriod;
    if (map.id == 4){
// Initial values for logs report form controls    
        
        reporturl += '&showsysmes='+map.showsysmes+'&showstates='+map.showstates+'&dateorder='+map.dateorder;
        if (map.showsysmes == null || map.showsysmes == 0) $("#lr_sysmes").attr('checked', false);
        if (map.showstates == null || map.showstates == 0) $("#lr_states").attr('checked', false);
        if (map.dateorder == 1){
            $("#lr_order").attr('value_', 1);
            $("#lr_order div.lr_order").addClass("lr_order_up");
        }        
        
    }
    reporturl += '&webui=1';
    /* Bind accordion handles click events */
// Now load the tree URL and activate it
    /*$("#view").append("<div class=\"viewids\" id=\"viewid"+map.viewselect+"\"></div>");*/



    $("#"+selectedMonTypeId+" + #treeview").append("<div class=\"viewids\" id=\"viewid"+map.viewselect+"\"></div>");
//    $("#view").empty();

    if (map.viewselect != selectedMonTypeView) {
        dispatchClickEvent(getMonTypeByViewId(map.viewselect));
    };


    if (typeof(map['expandednodes']) != 'undefined') {
        setTreeViewExpandedNodes(map.viewselect, map['expandednodes'].split(','));
    }

    initLiveTree("#"+selectedMonTypeId+"  + #treeview #viewid"+map.viewselect, treeurl,  onTreeNodeClick, function(){});
    
    
    $("#pleasewait").html("Generating&nbsp;report&nbsp;...<img src=\"images/pleasewait.gif\" />").css('display', 'block');
    disableall();
	

	dt = getServerDate();
	nocache = dt.getTime();
	reporturl += "&nocache="+nocache;
	
    doLoadReport(reporturl);
    
    function onEntriesPerPageChanged()
    {
        v = $("#numberofentries_val").val();
        if (v == parseInt(v)) {
            setCookie('entriesperpage', v);
            currEntriesPerPage = v;
        } else if (v != ""){
            $("#numberofentries_val").val(currEntriesPerPage);
        }
    }
    // http://www.mail-archive.com/jquery-en@googlegroups.com/msg43689.html
    // We have to handle all these events
    a = ['keyup', 'change', 'paste', 'cut'];
    for (i=0; i < a.length; i++) {
        $("#numberofentries_val").bind(a[i], function(){
            // Schedule refresh since value might not be updated at this moment yet
            setTimeout(onEntriesPerPageChanged, 100);
        });
    }
    
}

function onTreeNodeClick(el){
    
    var ctrlpart = $(el).attr('params').replace(/;state.*$/, '');
    ctrlpart = ctrlpart.replace(/:/g,"=").replace(/;/g,"&")
    try{        
        parms = ctrlpart.split(/&/i);
        tmp_obj_type = parms[0].split(/=/);
        tmp_obj_id = parms[1].split(/=/);
        tmp_obj_type = tmp_obj_type[1];
        tmp_obj_id = tmp_obj_id[1];
// Define new obj_type, obj_id and view
        map.obj_type = tmp_obj_type;
        map.obj_id = tmp_obj_id;
        map.view = map.viewselect;
        
    }catch (ex){
    } 
        
    var reportpart = '/nms/ui_report?' + '&id=' + map.id + "&" + ctrlpart.replace(/&?state=[0-9]+/,"");
    map["reportpart"] = reportpart.replace(/&(start|stop|id)=[^&]+/g,'');

// Focus element               
    $("#"+selectedMonTypeId+" + #treeview #viewid"+map.viewselect+" #browser span[@activenow=1]").removeClass("elemfocus");
    $(el).addClass("elemfocus").attr('activenow', 1);
	refreshMonitorsButtons();
       
// Get title           
    /*map["title"] = title_reg.exec($(el).html())[1];*/
    var mcnt = $(el).find(".moncount").length;
    map["title"] = $(el).find(".monname").html() + (mcnt ? $(el).find(".moncount").html() : "");
// Generate        
    generate_click();
    return false;
}

var doShowPW = false;
function showPleaseWait(){
    if (doShowPW){
        dt = getServerDate();
        $("#pleasewait").html("Generating&nbsp;report&nbsp;...<img src=\"images/pleasewait.gif?"+dt.getTime()+"\" />");
        disableall();
        $("#pleasewait").css('display', 'block');
    }
}


var lastLoadedUrl = "";

//
// Loads _url to #right, executes onReportLoaded() on success
//
// Affects next global variables:
//      sets up lastLoadedUrl to _url;
//      sets up doShowPW to false on success.
//

function doLoadReport(_url)
{
    // Customize number of entries per page value if needs
    if (currEntriesPerPage != defaultEntriesPerPage)
        _url += "&nentries=" + currEntriesPerPage;

    lastLoadedUrl = _url;
    $("#right").empty().load(_url, function(){
        onReportLoaded();
        doShowPW = false;
		var pageName = location.pathname.match(/\/nms\/(.*?html)/)[1];
		if (pageName != "") {
			if (pageName != "ui.html") {
				$("a").each(function(){
					$this = $(this);
					var newattr = $this.attr("href").replace("ui.html", pageName);
					$this.attr("href", newattr);
				});
			}
		}
    });
}
var pageReloadTimerId = -1;

/***
 * Fires after PAGE_RELOAD_TIMEOUT_MSECS msecs and reloads the whole
 * page.
 */
function reschedulePageReloading()
{
    if (pageReloadTimerId >= 0) {
        clearTimeout(pageReloadTimerId);
    }
    pageReloadTimerId = setTimeout(reloadPage, PAGE_RELOAD_TIMEOUT_MSECS);
}

var PAGE_RELOAD_TIMEOUT_MSECS = 3600*1000; // How often should page be reloaded

// when user is inactive
/***
 * @params:
 *      _url - report url to load. If not set then function will
 *             construct it using data from "map" global array.
 *             Multipage-report-related parameters are ignored.
 *
 * After report loading onReportLoaded() function is called.
 *
 */
function loadReport(_url) {

    doShowPW = true;
    setTimeout(showPleaseWait, 1000);

    datemodeselect_change();

    var reporturl = "";
    if (_url === undefined) {
        var reporturl = map["reportpart"] + '&id=' + $("#reportselect").val() + '&view=' + map.viewselect +
            '&start=' + $("#dtstart").val() + 'T' + $("#fromtime option:selected").val() +
            '&stop=' + $("#dtend").val() + 'T' + $("#totime option:selected").val();
        if (map.period_id !== undefined) {
            reporturl += '&period_id='+parseInt(map.period_id);
        }
        // If Logs report: add two new parameters
        if ($("#reportselect").val() == 4){
            reporturl += '&showstates='+( $("#lr_states").attr('checked')? 1 : 0) +
                '&showsysmes='+( $("#lr_sysmes").attr('checked')? 1 : 0)+
                '&dateorder='+$("#lr_order").attr('value_');
        }
    } else {
        reporturl = _url;
    }

    dt = getServerDate();
    nocache = dt.getTime();
    reporturl += "&nocache="+nocache;
    reporturl += "&webui=1"

// Now load the tree URL and activate it

    doLoadReport(reporturl);
}

function reloadPage()
{
    // get parameters from lastLoadedUrl
    var params = lastLoadedUrl.split('?');
    if (params.length > 0) {
        params.splice(0, 1);
        params = params.join('?');
        s = '/nms/ui.html?'+ params
            + '&viewselect=' + map.viewselect // the lastLoadedUrl can contain wrong view
                                              // if user switched the combobox but didn't click
                                              // any nodes in new tree
            + "&expandednodes=" + encodeURIComponent(getTreeViewExpandedNodes().join(','));
        location.href = s;
    } else {
        reschedulePageReloading();
        return ; // something is wrong
    }
}

/***
 * Should be called when report loading to
 * #right is finished. Fixes geometry, hides
 * "please wait" etc.
 */
function onReportLoaded()
{
    wrapEditHeaderFooterUrls();
    $("#pleasewait").css('display', 'none');
    enableall();
    adjust_splitter_height();	
    $(window).resize();
    
    // Use custom "onclick" handler for report page links
    $("#right").find("a.pagelink").each(function(){
        $(this).attr('href_s', $(this).attr('href')); // remove 'href' attribute to skip link's default behavior:
                                                      // it is better than use e.preventDefault() here because
                                                      // browser may handle it in a wrong way, i.e.:
                                                      // FireFox 3.5 shows message in "status" bar which stays there
                                                      // forever; IE6 reloads all images... not good
        $(this).removeAttr('href') 
               .addClass('a_with_no_href') /* fix mouse cursor and decorations */ ;
        
        $(this).click(function(e) {
            h = $(this).attr('href_s');
            s = h.split('?');
            if (s.length >= 2) {
                l = "/nms/ui_report?" + s[1];
                loadReport(l);
            }
        });
    });
    
    reschedulePageReloading();
}



function generate_click()
{
    // Update report if #right element exists
    if ($("#right").length > 0)
        loadReport();
}


function print_click() {
    var reporturl = lastLoadedUrl + "&print=1";
    
    reporturl = reporturl.replace(/ui_report/, 'report');
    window.open(reporturl, '_blank', '');
}

function populate_date_fields() {	
    var sdate = get_halfhour_date();

    var sd = date_datestring(sdate);
    var st = date_timestring(sdate);
    var ed = sd;
    var et = st;
	
	
// Not parse the start/stop strings	
    if (map.start === undefined) {
        map.start = sd+'T'+st;
    }
    if (map.stop === undefined) {
        map.stop = sd+'T'+st;
    }	
// Match the start
    var smatch = map.start.match(/^((\d{4})-(\d{2})-(\d{2}))T((\d{2}):(\d{2}):(\d{2}))$/);
    if (smatch) {
        var m = parseInt(smatch[7]);
        if (m < 29) {
           m = 0;
        } else {
           m = 30; 
        }
        sdate = new Date(smatch[2],smatch[3]-1,smatch[4],smatch[6],m,0);
        sd = date_datestring(sdate);
        st = date_timestring(sdate);
    } else {
        sdate = new Date(sdate.getTime() - 86400*1000);
        sd = date_datestring(sdate);
        st = date_timestring(sdate);
    }
// Match the stop    
    smatch = map.stop.match(/^((\d{4})-(\d{2})-(\d{2}))T((\d{2}):(\d{2}):(\d{2}))$/);
    if (smatch) {
        var m = parseInt(smatch[7]);
        var mup = ((m != 0) && (m != 30));
        if (m < 29) {
           m = 0;
        } else {
           m = 30; 
        }
        sdate = new Date(smatch[2],smatch[3]-1,smatch[4],smatch[6],m,0);
        if (mup) {
           sdate = new Date(sdate.getTime() + 30*60*1000);
        }
        ed = date_datestring(sdate);
        et = date_timestring(sdate);
    }
    
    dtf_set(sd,st,ed,et);
}

function fromtime_change() {
    $("#datemodeselect option").removeAttr("selected");
    $("#datemodeselect option[value='-']").attr("selected","selected");
    map.period_id = undefined;
}

function totime_change() {
    $("#datemodeselect option").removeAttr("selected");
    $("#datemodeselect option[value='-']").attr("selected","selected");
    map.period_id = undefined;
}

function dstart_select() {
    var dtext = $("#fromdate").val();
    $("#dtstart").attr('value', dtext);
//    $("#tstart").text(dtext + " " + $("#fromtime option:selected").val());
    $("#datemodeselect option").removeAttr("selected");
    $("#datemodeselect option[value='-']").attr("selected","selected");
    map.period_id = undefined;
}

function dend_select() {
    var dtext = $("#todate").val();
    $("#dtend").attr('value',dtext);
//    $("#tend").text(dtext + " " + $("#totime option:selected").val());
    $("#datemodeselect option").removeAttr("selected");
    $("#datemodeselect option[value='-']").attr("selected","selected");
    map.period_id = undefined;
}

function dtf_set(sd,st,ed,et) {
    $("#dtstart").attr('value',sd);
//    $("#tstart").text(sd+' '+st);
    $("#fromdate").val(sd);
    $("#fromtime option").removeAttr("selected");
    $("#fromtime option[value='"+st+"']").attr("selected","selected");
    $("#dtend").attr('value',ed);
//    $("#tend").text(ed+' '+et);
    $("#todate").val(ed);
    $("#totime option").removeAttr("selected");
    $("#totime option[value='"+et+"']").attr("selected","selected");
// Set start/stop parameters
    map.start = sd+'T'+st;    
    map.stop = ed+'T'+et;    
}



function datemodeselect_change(eo,parm) {
	
    var v = $("#datemodeselect option:selected").eq(0).val();
    var sd = '', st = '', ed = '', et = '';
    var tdate = get_halfhour_date();
//    var st = today.getFullYear() + '-' + (1+today.getMonth()) + '-' + today.getDate();
    if (parm !== undefined) {
        v = parm;
    }
    map["period_id"] = v;
    if (v != '-') {
        switch (parseInt(v)) {
// 1 - Today
            case 1:
                tdate = getServerDate();
                tdate.setHours(0, 0, 0);
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                tdate = new Date(tdate.getTime() + 86400*1000);
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 2 - Yesterday
            case 2:
                tdate = getServerDate();
                tdate.setHours(0, 0, 0);
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                tdate = new Date(tdate.getTime() - 86400*1000);
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 3 - Current week
            case 3:				
// Find closest Monday
                tdate = getServerDate();
                var dow = tdate.getDay();
                if (dow == 0) {
                    dow = 7;
                }
				// dow: 1 -- monday
				// 		...
				// 		7 -- sun
				
				// firstDayOfWeek: 0 -- monday
				//					...
				//					6 -- sun				
				dow --;
				firstDOW = firstDayOfWeek;
				
				// Solving equation: (dow - x) ~(mod 7) firstDOW
				
				tmpdelta = 0; // x
				if (dow >= firstDOW)
					tmpdelta = dow - firstDOW;
				else
					tmpdelta = dow+7 - firstDOW;
								
                tdate = new Date(tdate.getTime() - tmpdelta * 86400 * 1000);
					
// Set time to zero
                tdate.setHours(0,0,0);                
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                tdate = new Date(tdate.getTime() + (7*86400)*1000);
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 4 - Current month
            case 4:
// Get current month
                tdate = getServerDate();
                var sm = tdate.getMonth();
                var sy = tdate.getFullYear();
                var em = 1+tdate.getMonth();
                var ey = tdate.getFullYear();
                if (em >= 12) {
                    em = 0;
                    ey += 1;
                }
                tdate = new Date(sy, sm, 1, 0, 0, 0);
// Set time to zero
                tdate.setHours(0,0,0);                
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                tdate = new Date(ey, em, 1, 0, 0, 0);
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 5 - Last week
            case 5:
// Find closest Monday
                var dow = tdate.getDay();
                if (dow == 0) {
                    dow = 7;
                }
				
				// dow: 1 -- monday
				// 		...
				// 		7 -- sun
				
				// firstDayOfWeek: 0 -- monday
				//					...
				//					6 -- sun				
				dow --;
				firstDOW = firstDayOfWeek;
				
				// Solving equation: (dow - x) ~(mod 7) firstDOW
				
				tmpdelta = 0; // x
				if (dow >= firstDOW)
					tmpdelta = dow - firstDOW;
				else
					tmpdelta = dow+7 - firstDOW;
								
                tdate = new Date(tdate.getTime() - (tmpdelta+7) * 86400 * 1000);
// Set time to zero
                tdate.setHours(0,0,0);                
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                tdate = new Date(tdate.getTime() + (7*86400)*1000);
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 6 - Last month
            case 6:
// Get current month
                var sm = tdate.getMonth()-1;
                var sy = tdate.getFullYear();
                if (sm < 0) {
                    sm = 11;
                    sy -= 1;
                }
                var em = tdate.getMonth();
                var ey = tdate.getFullYear();
                tdate = new Date(sy, sm, 1, 0, 0, 0);
// Set time to zero
                tdate.setHours(0,0,0);                
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                tdate = new Date(ey, em, 1, 0, 0, 0);
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 7 - Week to date
            case 7:
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                tdate = new Date(tdate.getTime() - 7*86400*1000);
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 8 - 4 weeks to date
            case 8:
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                tdate = new Date(tdate.getTime() - 28*86400*1000);
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 9 - Last 4 hours
            case 9:
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                tdate = new Date(tdate.getTime() - 4*3600*1000);
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 10 - Last 8 hours
            case 10:
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                tdate = new Date(tdate.getTime() - 8*3600*1000);
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 11 - Last 24 hours
            case 11:
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                tdate = new Date(tdate.getTime() - 24*3600*1000);
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 12 - Last 3 days
            case 12:
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                tdate = new Date(tdate.getTime() - 3*86400*1000);
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 13 - Last 7 days
            case 13:
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                tdate = new Date(tdate.getTime() - 7*86400*1000);
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 14 - Last 30 days
            case 14:
                ed = date_datestring(tdate);
                et = date_timestring(tdate);
                tdate = new Date(tdate.getTime() - 30*86400*1000);
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
                break;
// 15 - Default period			
			case 15:
				ed = date_datestring(tdate);
                et = date_timestring(tdate);
                tdate = new Date(tdate.getTime() - (defaultReportingDays*24*3600*1000) - (defaultReportingHours*3600*1000));
                sd = date_datestring(tdate);
                st = date_timestring(tdate);
                dtf_set(sd,st,ed,et);
				break;
        }
    }
}

function togglecontrols_click() {
    
    var display_state = map['ctrlon'] ? "none" : "block";
    
    
    if (display_state == "none"){
        $("#togglecontrols > div.togglecontrols").addClass("togglecontrols_up");        
    } else{
        $("#togglecontrols > div.togglecontrols").removeClass("togglecontrols_up");
    }
    $("#header .ctrlon").css("display", display_state);
    
    map['ctrlon'] = ! map['ctrlon'];
    $("#right").css("height", map.sheight - $("#header").height() -20-bookmarksheight).trigger("resize"); 
// IE 7 scaling bug escaping
    if ($.browser.msie)
        if ($.browser.version >=7)
            $("#togglecontrols").parent().append(" ");
    
}          

// Load default settings:
//  - default reporting period,
//  - first day of week
// 
function loadReportingSettings()
{
	strUrl = "/nms/getreportingsettings";
	
	
	$.ajax({
		async: false,
		method: "GET",
		url:  strUrl,
		success: function(data){
			// Get default reporting period first
			err = parseInt($("root > info", $(data)).attr('error'));
			if (err == 0){
				defaultReportingHours =  parseInt($("root > info", $(data)).attr('hours'));
				defaultReportingDays = parseInt($("root > info", $(data)).attr('days'));
			
				h_s = (defaultReportingHours >1) ? "s" : "";
				d_s = (defaultReportingDays >1) ? "s" : "";
			} else{
				defaultReportingHours = 0;
				defaultReportingDays = 1;
				d_s = "";
				h_s = "";
			}

			// So, we have default reporting days and hours: add option to combobox
			selected= (map.period_id == 15) ? "selected=\"selected\"" : "";
			
			$("#datemodeselect").find("option[value=\"15\"]").html("Last "
					+ ((defaultReportingDays != 0) ? (defaultReportingDays + " Day" + d_s ) : "")  // "5 days"
					+ ((defaultReportingDays != 0 && defaultReportingHours != 0) ? " " : "")  // " " / ""
					+((defaultReportingHours != 0) ? (defaultReportingHours + " Hour" + h_s ) : "") + " (Default)");
				
			// Get first day of week
			firstDayOfWeek = parseInt($("root > firstdayofweek", $(data)).attr('val'));
			
			// Get server's time
			serversTime = (parseInt($("root > currtime", $(data)).attr('nsecsfrom1970')) * 1000);
			d = new Date();
			timeDiff = serversTime - d.getTime();
			
            // Get number of entries per report page value
            defaultEntriesPerPage = parseInt($("root > entriesperpage", $(data)).attr('val'));
            c = getCookie('entriesperpage');
            currEntriesPerPage = (c == null ? defaultEntriesPerPage : c);
            $("#numberofentries_val").val(currEntriesPerPage);
		}		
	});
}

/************ Handle Edit Header\Footer links ********************/

function wrapEditHeaderFooterUrls(){
	
	$("#right").find("div.reportHeader").each(function(){
		$(this).find("a").each(function(){
			if ($(this).attr('href').indexOf('/nms/userdata/editheader') >= 0){
				$(this).attr('href', '#');
				$(this).attr('target', '');
				$(this).attr('onClick', 'showEditHeaderFooter("header");');
				$(this).click(function(){
					showEditHeaderFooter("header");
				});
				
			}
		});
	});
	
	$("#right").find("div.reportFooter").each(function(){
		$(this).find("a").each(function(){
			if ($(this).attr('href').indexOf('/nms/userdata/editfooter') >= 0){
				$(this).attr('href', '#');
				$(this).attr('target', '');
				$(this).attr('onClick', 'showEditHeaderFooter("footer");');
				$(this).click(function(){
					showEditHeaderFooter("footer");
				});
			}
		});
	});
}
var HEADER = "header";
var FOOTER = "footer";

function showEditHeaderFooter(type){
	dt = getServerDate();
	nocache = dt.getTime();
	
	$("#right").empty().load("/nms/userdata/edit" + type + "?for_webui=1&nc="+nocache, function(txt){
			
	});
}
// on Preview click
function editHeaderFooterOnPreviewClick(type){
	dt = getServerDate();
	nocache = dt.getTime();
	
	tacontent =  $("#right").find("textarea").val();	
	$.ajax({
		type: 'POST',
		url: '/nms/userdata/edit'+type+'/preview?for_webui=1&nc='+nocache,
		data: {
			content: tacontent
		},
		async:	false,
		success: function (data){
			$("#right").html(data);
		}
			
	});
}
// on back click
function editHeaderFooterOnBackClick(type){
	dt = getServerDate();
	nocache = dt.getTime();
	
	$("#right").empty().load("/nms/userdata/edit" + type + "?back=1&for_webui=1&nc="+nocache, function(txt){
			
	});
}
// on restore click
function editHeaderFooterOnRestoreClick(type){
	dt = getServerDate();
	nocache = dt.getTime();
	$("#right").empty().load("/nms/userdata/edit" + type + "?restore=1&for_webui=1&nc="+nocache, function(txt){
			
	});
}
// on cancel click
function editHeaderFooterOnCancelClick(type){
	generate_click();
}
// on submit click
function editHeaderFooterOnSaveClick(type){
	dt = getServerDate();
	nocache = dt.getTime();
	$.ajax({
		type: 'POST',
		url: '/nms/userdata/edit'+type+'/submit?for_webui=1&nc='+nocache,
		data: {
			dosave: '1'
		},
		async:	false,
		success: function (data){
			generate_click();
		}
			
	});
}
